/* This code is distributed under the terms of Gnu Publice License */
/* The author is Przemek Borys <pborys@dione.ids.pl> */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "variables.h"
#include "utils.h"
#include "frac.h"
#include "superscript.h"
#include "subscript.h"
#include "sqrt.h"
#include "sum.h"
#include "prod.h"
#include "brace.h"
#include "array.h"

Tdim
dim (char *txt, struct Tgraph *graph)
{
  int i;
  int len = strlen (txt);	/* length of text passed to parse */
  char *tmp, *start, *end;	/* tmp variables */
  Tdim our;			/* the dimensions of our current object */
  Tdim out;			/* temporary variable */
  char *gpos;			/* points to the tree node's text */
  our.x = 0;
  our.y = 1;
  our.baseline = 0;
  graph->children = 0;		/* at the beginning the tree doesn't have
				   children. We must first find them */
  graph->txt = (char *) malloc (len + 1);	/* allocating the same length is
						   OK. Special characters in output
						   are 2 chars long--shorter than in
						   the input */
  gpos = graph->txt;		/* we setup now this pointer */
  *gpos = 0;
  for (i = 0; i < len; i++)
    {
      if ((txt[i] != '\\') && (txt[i] != '_') && (txt[i] != '^'))
	{
	  our.x++;
	  *gpos = txt[i];
	  gpos++;
	  *gpos = 0;
	}
      else
	{
	  if (strncmp (txt + i, "\\frac", 5) == 0)
	    i += dimFrac (txt + i, &gpos, &our, graph);
	  else if (txt[i] == '^')
	    {
	      if (txt[i + 1] == '{')
		i += dimSuperscript (txt + i + 1, &gpos, &our, graph);
	    }
	  else if (txt[i] == '_')
	    {
	      if (txt[i + 1] == '{')
		i += dimSubscript (txt + i + 1, &gpos, &our, graph);
	    }
	  else if (strncmp (txt + i, "\\sqrt", 5) == 0)
	    i += dimSqrt (txt + i, &gpos, &our, graph);
	  else if (strncmp (txt + i, "\\sum", 4) == 0)
	    i += dimSum (txt + i, &gpos, &our, graph);
	  else if (strncmp (txt + i, "\\prod", 4) == 0)
	    i += dimProd (txt + i, &gpos, &our, graph);
	  else if (strncmp (txt + i, "\\int", 4) == 0)
	    i += dimInt (txt + i, &gpos, &our, graph);
	  else if (strncmp (txt + i, "\\oint", 5) == 0)
	    i += dimOint (txt + i, &gpos, &our, graph);
	  else if (strncmp (txt + i, "\\infty", 6) == 0)
	    {
	      strcat (gpos, "oo");
	      gpos += 2;
	      our.x += 2;
	      i += 5;
	    }
	  else if ((strncmp (txt + i, "\\left", 5) == 0) ||
		   (strncmp (txt + i, "\\right", 6) == 0))
	    i += dimBrace (txt + i, &gpos, &our, graph);
	  else if (strncmp (txt + i, "\\begin{array}", 6) == 0)
	    i += dimArray (txt + i, &gpos, &our, graph);
	  else if (txt[i] == '\\')	/* quote mark--must be last here */
	    {
	      i++;
	      *gpos = txt[i];
	      gpos++;
	      *gpos = 0;
	    }
	  else
	    our.x++;		/* some error happened, but we ignore it */
/*-----------------------------------------------------------------*/
	}
    }
  graph->dim = our;
  return our;
}
