/* This code is distributed under the terms of Gnu Publice License */
/* The author is Przemek Borys <pborys@dione.ids.pl> */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "eqascii.h"

int
main (int argc, char *argv[])
{
  struct Tgraph *graph=malloc(sizeof(struct Tgraph));
  char **screen;
  int i, j;
  if (argc < 2)
    {
      fprintf (stderr, "No equation found at command line! Aborting.\n");
      exit (1);
    }
  graph->up = 0;
  graph->down = 0;
  graph->children = 0;
  dim (preparse (argv[1]), graph);
  screen = draw (graph);
  for (i = 0; i < graph->dim.y; i++)
    {
      for (j = 0; j < graph->dim.x; j++)
	printf ("%c", screen[i][j]);
      printf ("\n");
    }
  dealloc(graph); 
  return 0;
}
