/* This code is distributed under the terms of Gnu Publice License */
/* The author is Przemek Borys <pborys@dione.ids.pl> */
#include <string.h>
#include "utils.h"
#include "variables.h"
#include "dim.h"

int
dimSqrt (char *found, char **Gpos, Tdim * Our, struct Tgraph *graph)
{
#define gpos (*Gpos)
#define our (*Our)
  char *start, *end, *tmp;
  Tdim out;

  *gpos = 1;			/* mark the sqrt{} position as #1#4 */
  gpos++;
  *gpos = 4;
  gpos++;
  *gpos = 0;

  start = strchr (found, '{');
  end = findClosingBrace (start + 1);
  *end = 0;
  tmp = strdup (start + 1);
  *end = '}';
  out = dim (tmp, newChild (graph));
  free (tmp);

  out.y++;			/* add the line for top of sqrt drawing */

  if (our.baseline < out.baseline)
    {
      our.y += (out.baseline - our.baseline);
      our.baseline = out.baseline;
    }
  if (our.y - our.baseline < (out.y - out.baseline))
    {
      our.y = (out.y - out.baseline) + our.baseline;
    }
  our.x += out.x + 2;
  return end - (found);
#undef gpos
#undef our
}

void
drawSqrt (int *Kid, int *Curx, int *Cury, char ***screen, struct Tgraph *graph)
{
#define kid (*Kid)
#define curx (*Curx)
#define cury (*Cury)
  int i;
  (*screen)[cury + graph->down[kid]->dim.baseline][curx++] = '\\';
  drawInternal (screen, graph->down[kid], curx + 1, cury - (graph->down[kid]->dim.y - (graph->down[kid]->dim.baseline + 1)));
  for (i = 0; i < graph->down[kid]->dim.y; i++)
    (*screen)[cury + graph->down[kid]->dim.baseline - i][curx] = '|';
  curx++;
  for (i = 0; i < graph->down[kid]->dim.x; i++)
    (*screen)[cury - (graph->down[kid]->dim.y) +
	      (graph->down[kid]->dim.baseline)][curx++] = '_';
  kid++;
}
