/* This code is distributed under the terms of Gnu Publice License */
/* The author is Przemek Borys <pborys@dione.ids.pl> */
#include <string.h>
#include "utils.h"
#include "variables.h"
#include "dim.h"

int
dimSuperscript (char *found, char **Gpos, Tdim * Our, struct Tgraph *graph)
{
#define gpos (*Gpos)
#define our (*Our)
  char *start = found, *end, *tmp;
  Tdim out;

  *gpos = 1;			/* mark the superscript as #1#2 */
  gpos++;
  *gpos = 2;
  gpos++;
  *gpos = 0;

  end = findClosingBrace (start + 1);
  *end = 0;
  tmp = strdup (start + 1);
  *end = '}';
  out = dim (tmp, newChild (graph));
  free (tmp);
  if (out.y + 1 > our.y - our.baseline)
    our.y = our.baseline + out.y + 1;

  if (graph->txt >= gpos - 4)	/* check if we had a subscript before */
    {
      if ((*(gpos - 4) == 1) && (*(gpos - 3) == 3))	/* yep, we had it--our superscript will start at the same pos as the subscript */
	{
	  int width = graph->down[graph->children - 1]->dim.x;
	  if (width < out.x)
	    our.x += out.x - width;
	}
      else
	our.x += out.x;
    }
  else
    our.x += out.x;
  return end - (found - 1);
}

void
drawSuperscript (int *Kid, int *Curx, int *Cury, char ***screen, struct Tgraph *graph, char *txt)
{
#define kid (*Kid)
#define curx (*Curx)
#define cury (*Cury)
  int width = graph->down[kid]->dim.x;
  if (txt - 3 >= graph->txt)
    {
      if ((*(txt - 3) == 1) && (*(txt - 2) == 3))
	{
	  drawInternal (screen, graph->down[kid], curx - (graph->down[kid - 1]->dim.x), cury - (graph->down[kid]->dim.y));
	  if (width > graph->down[kid - 1]->dim.x)
	    curx += width - graph->down[kid - 1]->dim.x;
	}
      else
	{
	  drawInternal (screen, graph->down[kid], curx, cury - (graph->down[kid]->dim.y));
	  curx += width;
	}
    }
  else
    {
      drawInternal (screen, graph->down[kid], curx, cury - (graph->down[kid]->dim.y));
      curx += width;
    }
  kid++;

}
